#pragma once
#include <iostream>
#include <dshow.h>

using namespace std;

class CVideoWindow
{
public:
	CVideoWindow(string SourceName);
	~CVideoWindow(void);

	void Play(void);
	void Stop(void);
	void Pause();

	void ChildWindow(HWND hOwner,int Width,int Height,int PosX,int PosY)
	{
		pVideoWindow->put_MessageDrain((OAHWND)hOwner);

		pVideoWindow->put_Owner((OAHWND)hOwner);
		pVideoWindow->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS | WS_CLIPCHILDREN);

		SetWindowWidth(Width);
		SetWindowHeight(Height);

		POINT p = {PosX,PosY};
		SetWindowPosition(p);

	}

	void SetWindowHeight(long Value)
	{
		pVideoWindow->put_Height(Value);
	}

	int GetWindowHeight(void)
	{
		long Value;
		pVideoWindow->get_Height(&Value);
		return Value;
	}

	void SetWindowWidth(long Value)
	{
		pVideoWindow->put_Width(Value);
	}

	int GetWindowWidth(void)
	{
		long Value;
		pVideoWindow->get_Width(&Value);
		return Value;
	}

	void SetWindowPosition(POINT p)
	{
		pVideoWindow->SetWindowPosition(p.x,p.y,GetWindowWidth(),GetWindowHeight());
	}

	POINT GetWindowPosition()
	{
		long x,y,Width,Height;
		pVideoWindow->GetWindowPosition(&x,&y,&Width,&Height);
		
		POINT p;
		p.x = x;
		p.y = y;

		return p;
	}

	void SetStyle(long style)
	{
		pVideoWindow->put_WindowStyle(style);
	}

	long GetStyle(void)
	{
		long Value;
		pVideoWindow->get_WindowStyle(&Value);
		return Value;
	}

	void SetOwner(HWND hOwner)
	{
		pVideoWindow->put_Owner((OAHWND)hOwner);
	}

	/* ʒB͈͂́A-10000ij`0iőj܂ŁB */
	void SetVolume(int Value)
	{
		pBasicAudio->put_Volume(Value);
	}

	RECT GetVideoSize(void)
	{
		RECT Rect;

		pBasicVideo->get_VideoHeight(&Rect.bottom);
		pBasicVideo->get_VideoWidth(&Rect.right);

		return Rect;
	}

	void SetForeground(void)
	{
		pVideoWindow->SetWindowForeground(OATRUE);
	}

	void Visible(bool Value)
	{
		if(Value == true)
		{
			pVideoWindow->put_Visible(OATRUE);
		}else{
			pVideoWindow->put_Visible(OAFALSE);
		}
	}
private:
	string mSourceName;

	/* DirectShow֘A */
	IGraphBuilder *pGraphBuilder;
	IMediaControl *pMediaControl;
	IVideoWindow *pVideoWindow;
	IBasicAudio *pBasicAudio;
	IBasicVideo *pBasicVideo;
};