#include <windows.h>
#include <windowsx.h>

#include "CVideoWindow.h"

#define CLASS_NAME "sohosai2007"
#define TITLE_NAME "ԕՃCu 2007"
#define VOLUME_SET WM_USER + 1

enum SELECTED_VIDEO {VIDEO1,VIDEO2,VIDEO3,VIDEO4};

HINSTANCE ghInst;

LRESULT CALLBACK WindowProc(HWND hWnd,UINT msg,WPARAM wp,LPARAM lp);

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst,LPSTR lpsCmdLine,int nCmdShow)
{
	MSG msg;
	BOOL bRet;
	HWND hWnd;
	WNDCLASSEX WindowClass;
	
	CoInitialize(NULL);

	ghInst = hInst;

	WindowClass.cbSize = sizeof(WNDCLASSEX);
	WindowClass.style = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	WindowClass.lpfnWndProc = WindowProc;
	WindowClass.cbClsExtra = 0;
	WindowClass.cbWndExtra = 0;
	WindowClass.hInstance = ghInst;
	WindowClass.hIcon = (HICON)LoadImage
	(
		NULL,MAKEINTRESOURCE(IDI_APPLICATION),
		IMAGE_ICON,0,0,
		LR_DEFAULTSIZE | LR_SHARED
	);
	WindowClass.hCursor = (HCURSOR)LoadImage
	(
		NULL,MAKEINTRESOURCE(IDC_ARROW),
		IMAGE_CURSOR,0,0,
		LR_DEFAULTSIZE | LR_SHARED
	);
	WindowClass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	WindowClass.lpszMenuName = NULL;
	WindowClass.lpszClassName = CLASS_NAME;
	WindowClass.hIconSm = (HICON)LoadImage
	(
		NULL,MAKEINTRESOURCE(IDI_APPLICATION),
		IMAGE_ICON,0,0,
		LR_DEFAULTSIZE | LR_SHARED
	);

	RegisterClassEx(&WindowClass);

	hWnd = CreateWindow
	(
		CLASS_NAME,TITLE_NAME,
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,CW_USEDEFAULT,
		640,480,
		NULL,NULL,ghInst,NULL
	);

	ShowWindow(hWnd,SW_SHOWNORMAL);

	while ((bRet = GetMessage(&msg, NULL, 0, 0)) != 0)
	{
		if (bRet == -1)
		{
			break;
		}else{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	CoUninitialize();

	return 0;
}

LRESULT CALLBACK WindowProc(HWND hWnd,UINT msg,WPARAM wp,LPARAM lp)
{
	static CVideoWindow *Video1;
	static CVideoWindow *Video2;
	static CVideoWindow *Video3;
	static CVideoWindow *Video4;

	static HWND hVolumeUp;
	static HWND hVolumeDown;

	static int Volume = 0;
	static SELECTED_VIDEO Selected = VIDEO1;

	switch(msg)
	{
	case WM_CREATE:
		{
			hVolumeUp = CreateWindow("BUTTON","+",WS_CHILD | WS_VISIBLE,0,0,20,20,hWnd,(HMENU)10001,ghInst,NULL);
			hVolumeDown = CreateWindow("BUTTON","-",WS_CHILD | WS_VISIBLE,0,0,20,20,hWnd,(HMENU)10002,ghInst,NULL);

			Video1 = new CVideoWindow("http://130.158.203.1/united?MSWMExt=.asf");
			Video2 = new CVideoWindow("http://130.158.203.1/active?MSWMExt=.asf");
			Video3 = new CVideoWindow("http://130.158.203.1/kaikan?MSWMExt=.asf");
			Video4 = new CVideoWindow("http://130.158.203.1/matsumi?MSWMExt=.asf");

			RECT ClientRect;
			GetClientRect(hWnd,&ClientRect);

			/* rfĨTCY̎w */
			int VideoHeight = (ClientRect.bottom - 20) / 2;
			int VideoWidth = VideoHeight * (4.0 / 3.0);

			Video1->ChildWindow(hWnd,VideoWidth,VideoHeight,0,0);
			Video2->ChildWindow(hWnd,VideoWidth,VideoHeight,VideoWidth,0);
			Video3->ChildWindow(hWnd,VideoWidth,VideoHeight,0,VideoHeight);
			Video4->ChildWindow(hWnd,VideoWidth,VideoHeight,VideoWidth,VideoHeight);

			Video1->SetVolume(-10000);
			Video2->SetVolume(-10000);
			Video3->SetVolume(-10000);
			Video4->SetVolume(-10000);

			Video1->Play();
			Video2->Play();
			Video3->Play();
			Video4->Play();
		}

		break;
	case WM_PAINT:
		{
			RECT ClientRect;
			GetClientRect(hWnd,&ClientRect);

			HDC hdc = GetDC(hWnd);

			TextOut(hdc,ClientRect.right - 190,ClientRect.bottom - 20,"",4);

			char Temp[10];
			itoa(Volume,Temp,10);

			/* x󔒂œhԂĂ`悷 */
			TextOut(hdc,ClientRect.right - 90,ClientRect.bottom - 20,"@@@",6);
			TextOut(hdc,ClientRect.right - 90,ClientRect.bottom - 20,Temp,strlen(Temp));

			/* Đ`l̕\ */
			itoa(Selected + 1,Temp,10);
			char Output[20] = "`lF";
			strcat(Output,Temp);
			TextOut(hdc,ClientRect.right - 400,ClientRect.bottom - 20,Output,strlen(Output));

			ReleaseDC(hWnd,hdc);
		}
		break;
	case WM_RBUTTONUP:
		{
			RECT ClientRect;
			GetClientRect(hWnd,&ClientRect);

			int VideoHeight = (ClientRect.bottom - 20) / 2;
			int VideoWidth = VideoHeight * (4.0 / 3.0);

			/* XN[WNCAgW֕ϊ */
			POINT CursorPos;
			GetCursorPos(&CursorPos);
			ScreenToClient(hWnd,&CursorPos);

			int X = CursorPos.x;
			int Y = CursorPos.y;

			/* rfI̐؂ւ */
			if(0 <= X && 0 <= Y && X <= VideoWidth && Y <= VideoHeight)
			{
				delete Video1;
				Video1 = new CVideoWindow("http://130.158.203.1/united?MSWMExt=.asf");
				Video1->ChildWindow(hWnd,VideoWidth,VideoHeight,0,0);
				Video1->Play();
			}
			if(VideoWidth <= X && 0 <= Y && X <= VideoWidth * 2 && Y <= VideoHeight)
			{
				delete Video2;
				Video2 = new CVideoWindow("http://130.158.203.1/active?MSWMExt=.asf");
				Video2->ChildWindow(hWnd,VideoWidth,VideoHeight,VideoWidth,0);
				Video2->Play();
			}
			if(0 <= X && VideoHeight <= Y && X <= VideoWidth && Y <= VideoHeight * 2)
			{
				delete Video3;
				Video3 = new CVideoWindow("http://130.158.203.1/kaikan?MSWMExt=.asf");
				Video3->ChildWindow(hWnd,VideoWidth,VideoHeight,0,VideoHeight);
				Video3->Play();
			}
			if(VideoWidth <= X && VideoHeight <= Y && X <= VideoWidth * 2 && Y <= VideoHeight * 2)
			{
				delete Video4;
				Video4 = new CVideoWindow("http://130.158.203.1/matsumi?MSWMExt=.asf");
				Video4->ChildWindow(hWnd,VideoWidth,VideoHeight,VideoWidth,VideoHeight);
				Video4->Play();
			}

			SendMessage(hWnd,VOLUME_SET,NULL,NULL);

		}
		break;
	case WM_LBUTTONUP:
		{
			RECT ClientRect;
			GetClientRect(hWnd,&ClientRect);

			int VideoHeight = (ClientRect.bottom - 20) / 2;
			int VideoWidth = VideoHeight * (4.0 / 3.0);

			/* XN[WNCAgW֕ϊ */
			POINT CursorPos;
			GetCursorPos(&CursorPos);
			ScreenToClient(hWnd,&CursorPos);

			int X = CursorPos.x;
			int Y = CursorPos.y;

			/* rfI̐؂ւ */
			if(0 <= X && 0 <= Y && X <= VideoWidth && Y <= VideoHeight)
			{
				Selected = VIDEO1;
			}
			if(VideoWidth <= X && 0 <= Y && X <= VideoWidth * 2 && Y <= VideoHeight)
			{
				Selected = VIDEO2;
			}
			if(0 <= X && VideoHeight <= Y && X <= VideoWidth && Y <= VideoHeight * 2)
			{
				Selected = VIDEO3;
			}
			if(VideoWidth <= X && VideoHeight <= Y && X <= VideoWidth * 2 && Y <= VideoHeight * 2)
			{
				Selected = VIDEO4;
			}

			SendMessage(hWnd,VOLUME_SET,NULL,NULL);
			InvalidateRect(hWnd,NULL,false);
		}
		break;
	case WM_SIZE:
		{
			//Video1->Pause();
			//Video2->Pause();
			//Video3->Pause();
			//Video4->Pause();

			//Video1->Visible(false);
			//Video2->Visible(false);
			//Video3->Visible(false);
			//Video4->Visible(false);

			RECT ClientRect;
			GetClientRect(hWnd,&ClientRect);

			/* rfĨTCY̎w */
			int VideoHeight = (ClientRect.bottom - 20) / 2;
			int VideoWidth = VideoHeight * (4.0 / 3.0);

			Video1->SetWindowWidth(VideoWidth);
			Video1->SetWindowHeight(VideoHeight);
			Video2->SetWindowWidth(VideoWidth);
			Video2->SetWindowHeight(VideoHeight);
			Video3->SetWindowWidth(VideoWidth);
			Video3->SetWindowHeight(VideoHeight);
			Video4->SetWindowWidth(VideoWidth);
			Video4->SetWindowHeight(VideoHeight);

			/* rfÏʒuw */
			POINT p1 = {0,0};
			Video1->SetWindowPosition(p1);
			POINT p2 = {VideoWidth,0};
			Video2->SetWindowPosition(p2);
			POINT p3 = {0,VideoHeight};
			Video3->SetWindowPosition(p3);
			POINT p4 = {VideoWidth,VideoHeight};
			Video4->SetWindowPosition(p4);

			//Video1->Visible(true);
			//Video2->Visible(true);
			//Video3->Visible(true);
			//Video4->Visible(true);

			//Video1->Play();
			//Video2->Play();
			//Video3->Play();
			//Video4->Play();

			/* Rg[̈ʒu̕ύX */
			SetWindowPos(hVolumeUp,HWND_TOP,ClientRect.right - 150,ClientRect.bottom - 20,0,0,SWP_NOSIZE);
			SetWindowPos(hVolumeDown,HWND_TOP,ClientRect.right - 130,ClientRect.bottom - 20,0,0,SWP_NOSIZE);

			InvalidateRect(hWnd,NULL,false);

		}
		break;
	case WM_COMMAND:
		{
			/* {[̕ύX */
			if(wp == 10001)
			{
				if(Volume + 1 <= 100)
				{
					Volume++;
				}
			}

			if(wp == 10002)
			{
				if(Volume - 1 >= 0)
				{
					Volume--;

				}
			}

			/* ݒ */
			if(wp == 10001 || wp == 10002)
			{
				SendMessage(hWnd,VOLUME_SET,NULL,NULL);
				InvalidateRect(hWnd,NULL,false);
			}
		}
		break;

	case VOLUME_SET:
		{
			int VoluemValue = -(60.0 - (Volume / 2.0)) * 100.0;

			switch(Selected)
			{
			case VIDEO1:
				Video1->SetVolume(VoluemValue);
				Video2->SetVolume(-10000);
				Video3->SetVolume(-10000);
				Video4->SetVolume(-10000);
				break;
			case VIDEO2:
				Video1->SetVolume(-10000);
				Video2->SetVolume(VoluemValue);
				Video3->SetVolume(-10000);
				Video4->SetVolume(-10000);
				break;
			case VIDEO3:
				Video1->SetVolume(-10000);
				Video2->SetVolume(-10000);
				Video3->SetVolume(VoluemValue);
				Video4->SetVolume(-10000);
				break;
			case VIDEO4:
				Video1->SetVolume(-10000);
				Video2->SetVolume(-10000);
				Video3->SetVolume(-10000);
				Video4->SetVolume(VoluemValue);
				break;
			}
		}
		break;
	case WM_CLOSE:
		DestroyWindow(hWnd);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);

		Video1->Visible(false);
		Video2->Visible(false);
		Video3->Visible(false);
		Video4->Visible(false);
		
		Video1->SetOwner(NULL);
		Video2->SetOwner(NULL);
		Video3->SetOwner(NULL);
		Video4->SetOwner(NULL);

		delete Video1;
		delete Video2;
		delete Video3;
		delete Video4;

		break;
	}

	return DefWindowProc(hWnd,msg,wp,lp);
}
